'use strict';

var mainPage;
echo('apd-> code loaded');
window.onload = function () {
	echo('apd-> window loaded');
	var language, autoPowerDownTime, standByMode, countDownTimer,
		environment = JSON.parse(gSTB.GetEnv(JSON.stringify({varList: ['language', 'standByMode', 'autoPowerDownTime']}))).result;

	window.resizeTo(EMULATION ? window.outerWidth : screen.width, EMULATION ? window.outerHeight : screen.height);
	window.moveTo(0, 0);

	language = environment.language;
	autoPowerDownTime = environment.autoPowerDownTime;
	standByMode = parseInt(environment.standByMode, 10);

	if ( !autoPowerDownTime || autoPowerDownTime === '0' ) {
		echo('apd-> option turned off, stop and close itself');
		stbWebWindow.close(); // APD option turned off, stop and close itself
		return;
	}

	gettext.init({name: language, path: 'lang'}, function () {
		echo('apd-> lang loaded');
		var text1    = _('Device will be shut down in '),
			text2    = _(' seconds.<br>Press any key to cancel.'),
			timeLeft = 59;

		mainPage = new CPage();
		mainPage.name = 'main';
		window.currCPage = window.ServiceMenu = mainPage;
		mainPage.Init(document.body.children[0]);
		mainPage.Show(true);
		mainPage.messageHint = new CModalHint(mainPage, text1 + timeLeft + text2, null, true);
		(function countDown () {
			echo('apd-> timeLeft:' + timeLeft);
			timeLeft--;
			mainPage.messageHint.content.innerHTML = text1 + timeLeft + text2;
			if ( timeLeft > 0 ) {
				countDownTimer = window.setTimeout(countDown, 1000);
			} else {
				echo('apd-> standByTrigger()');
				standByTrigger();
			}
		})();
		mainPage.messageHint.Show(true);
		echo('apd-> loading finished, continue timer');
	});


	function standByTrigger () {
		var standByStatus = !gSTB.GetStandByStatus();//,
			//messageResived;

		// check stand by mode trigger
		if ( gSTB.StandByMode !== standByMode ) { gSTB.StandByMode = standByMode; }
		echo('apd-> current gSTB.StandByMode: ' + (gSTB.StandByMode == 1 ? 'active' : (gSTB.StandByMode == 3 ? 'deep' : 'error')));
		// deep standBy mode
		if ( standByMode === 3 ) {
			echo('apd-> go to deep');
			document.body.style.display = 'none';
			stbWindowMgr.hideWindow(stbWebWindow.windowId()); // hide itself
			setTimeout(function () {
				gSTB.SetLedIndicatorMode(2);
				gSTB.StandBy(standByStatus);
				gSTB.SetLedIndicatorMode(1);
				echo('apd-> exit from deep');
				stbWebWindow.close(); // close itself
			}, 500); // need some time to hide apd window
			return;
		}

		// active standBy mode
		if ( standByStatus ) {
			echo('apd-> make page black');
			document.body.style.display = 'none';
			// try to redirect to portal standby system
//			echo('apd-> send msg to portal with id: ' + getWindowIdByName(WINDOWS.PORTAL) + ' || ' + getWindowIdByName(WINDOWS.PORTALS_LOADER) + ' || 1');
//			messageResived = stbWebWindow.messageSend(getWindowIdByName(WINDOWS.PORTAL) || getWindowIdByName(WINDOWS.PORTALS_LOADER) || 1, 'portal.standbyMode', '');
//			if ( !messageResived ) {
			echo('apd-> Go to active');
			stbWindowMgr.hideWindow(stbWebWindow.windowId()); // hide itself
			gSTB.SetLedIndicatorMode(2);
			gSTB.StandBy(standByStatus);
			gSTB.Stop();
//			} else {
//				echo('apd-> msg received. Closed');
//				stbWebWindow.close(); // portal will make all work so close itself
//			}
		} else {
			echo('apd-> wake up from active and close itself');
			gSTB.StandBy(standByStatus);
			gSTB.SetLedIndicatorMode(1);
			stbWebWindow.close(); // close itself
		}
	}


	document.addEventListener('keydown', function ( event ) {
		echo('apd-> key pressed, filtering');
		// get real key code or exit
		if ( !eventPrepare(event, false, window.currCPage && window.currCPage.name) ) { return;}
		// global events
		echo('apd-> key filtered. is it power in turned active standby?' + (event.code === KEYS.POWER) + '&&' + (standByMode !== 3) + '&&' + gSTB.GetStandByStatus());
		if ( event.code === KEYS.POWER && standByMode !== 3 && gSTB.GetStandByStatus() ) {
			standByTrigger();
		} else {
			echo('apd-> key pressed, stop timer, close itself');
			// standby cancelled, close itself
			window.clearTimeout(countDownTimer);
			stbWebWindow.close();
		}
	});
};
